/*
define variable code-page-list as character no-undo.
define variable collation-list as character no-undo.
define variable ix as integer no-undo.
define variable jx as integer no-undo.


code-page-list = get-codepages.
repeat ix = 1 to num-entries(code-page-list):
   display entry(ix, code-page-list) format "x(19)" column-label "code page"
      with down frame a.
   collation-list = get-collations(entry(ix, code-page-list)).
   
   repeat jx = 1 to num-entries(collation-list):
      display entry(jx, collation-list) format "x(19)"
         column-label "collation"
         with down frame a.
      down with frame a.
   end.
end.
*/

def var lc1 as longchar view-as editor large size 15 by 1.
def var lc2 as longchar  view-as editor large size 15 by 1 init "abc" .
def var lc3 as longchar  view-as editor large size 15 by 1.
def var i as integer.
def var vsize as integer.
def var c1 as char.
def var c2 as char.
def var c3 as char.

function getlongchar returns longchar(input sz as integer, input c as char, input lcv as longchar) forward.

/* codepage */
fix-codepage(lc1) = "utf-8".
lc1 = "abc".
lc2 = "abc".
lc2 = codepage-convert(lc2,"ibm850").
display skip "codepage lc1 lc2" get-codepage(lc1) get-codepage(lc2)  with frame f1 no-labels.

/* assignment c=lc */
vsize = 31000.
do i=1 to vsize: 
   lc1 = lc1 + "a".
end.
c1 = lc1.

display skip "length lc c:" length(lc1) length(c1)  with frame f1 no-labels.

/* matches, begins */
lc1="abc". c1="ab*". c2="ab".
display "lc matches c:" lc1 c1 lc1 matches(c1) with frame f2 no-labels.
display "lc begins c:" lc1 c2 lc1 begins(c2)  with frame f3 no-labels.

/* function parameters */
lc2 = "x".
c1 = getlongchar(31000, string(lc2) , c1).

function getlongchar returns longchar(input sz as integer, input c as char,  input lcv as longchar).
    define variable res as longchar.
    define variable i as integer.
    do i = 1 to sz:
       res = res + c.  
    end.
    return res.
end function.

/* cbit */
lc1="abc".
c1="abc".
display "cbit" lc1 "2"  _cbit(c1,1) with frame f4 no-labels.

/* substring */
lc1 = substring ( lc1, 2,1,"character").
display skip "substring" lc1 with frame f5 no-labels.

/**/                                                                               
c1 = "[xdx]".
c2 = codepage-convert(c1,"utf-8").
c3 = codepage-convert(c1,"ibm850").
display c1 skip c2 skip c3 skip with frame f6 no-labels.

/**/
lc1 = "[xdxx]".
lc2 = codepage-convert(c1,"utf-8").
lc3 = codepage-convert(c1,"ibm850").
display lc1 skip lc2 skip lc3 skip with frame f6 no-labels.

/*asc*/
c1  = "x".
lc1 = "abc".
lc1= chr(67).
c1 = caps(lc1).
display c1 skip         
        with frame f7 no-labels.
/*lookup*/
lc1 = "a,b,c,d".
c2 = "b".
c3 = lc1.
c3 = maximum(c1,c2).
lc2 = "x".
c1 = lc1.
c3 = replace(c1,lc1,lc2) .
display lookup(c2,c3) skip         
        c3 skip 
        "numentries:" space num-entries(lc1,",") skip 
        string(lc3,"x(10)") skip 
        with frame f7 no-labels.
c2 = "s: &1".
c2= substitute(c2,lc2).
display skip c2 with frame f8 no-labels.

/*errors char */
c1="x". lc1="x2".
display _cbit(c1,1). /*e1*/
display asc(c1).     /*e2*/
c1 = getlongchar(31000, c1 , lc1). /*e3*/

/*errors longchar*/
def var m as memptr.
set-size(m) = 2.
put-string(m,1) = "a".
lc1="utf-8". c1=lc1.
fix-codepage(lc1) = c1. /*e4*/
is-codepage-fixed(lc1).  /*e5*/
lc1="qq".
c1 = base64-encode(m).
m = base64-decode(c1).
c2 = string(m).

display c1 c2.
get-codepage(lc1). /*e6*/
